package com.tptj.demo.hg.transfer.data.set.manager.provider;

import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.data.AbstractParameterTableData;
import com.fr.general.data.DataModel;
import com.fr.general.xml.GeneralXMLTools;
import com.fr.script.Calculator;
import com.fr.stable.EncodeConstants;
import com.fr.stable.StringUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/9/7
 **/
public class SpData extends AbstractParameterTableData {
    private Conf<String> config = Holders.simple(StringUtils.EMPTY);

    public String getConfig() {
        return config.get();
    }

    public void setConfig( String config) {
        this.config.set(config);
    }

    @Override
    public DataModel createDataModel(Calculator calculator) {
        return new SpDataModel( calculator,
                Calculator.processParameters(calculator,super.getParameters(calculator)),
                getConfig() );
    }

    @Override
    public void readXML(XMLableReader reader) {
        super.readXML(reader);
        if (reader.isChildNode()){
            if ("Attributes".equals(reader.getTagName())) {
                try{
                    String conf = new String(GeneralXMLTools.readByteArray(reader), EncodeConstants.ENCODING_UTF_8);
                    setConfig(conf);
                }catch(Exception e){
                    setConfig(StringUtils.EMPTY);
                }
            }
        }
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        super.writeXML(writer);
        writer.startTAG("Attributes");
        try{
            GeneralXMLTools.writeByteArray(writer, getConfig().getBytes(EncodeConstants.ENCODING_UTF_8));
        }catch(Exception e){}
        writer.end();
    }
}
