package com.tptj.demo.hg.transfer.data.set.manager.provider;

import com.fr.base.BaseUtils;
import com.fr.base.Parameter;
import com.fr.design.data.datapane.preview.PreviewTablePane;
import com.fr.design.data.tabledata.tabledatapane.AbstractTableDataPane;
import com.fr.design.gui.ibutton.UIButton;
import com.fr.design.gui.icontainer.UIScrollPane;
import com.fr.design.gui.ilable.UILabel;
import com.fr.design.gui.itableeditorpane.ParameterTableModel;
import com.fr.design.gui.itableeditorpane.UITableEditorPane;
import com.fr.design.gui.itableeditorpane.UITableModelAdapter;
import com.fr.design.gui.itextarea.UITextArea;
import com.fr.design.layout.TableLayout;
import com.fr.design.layout.TableLayoutHelper;
import com.fr.script.Calculator;
import com.fr.stable.ParameterProvider;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/9/7
 **/
public class SpDataPane extends AbstractTableDataPane<SpData> {

    private UITextArea config;
    private UITableEditorPane<ParameterProvider> parameterTableEditorPane;

    public SpDataPane(){
        config = new UITextArea();
        setLayout(new BorderLayout());

        UIButton preview = new UIButton(BaseUtils.readIcon("/com/fr/design/images/m_file/preview.png"));
        preview.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        PreviewTablePane.previewTableData(SpDataPane.this.updateBean());
                    }
                });
            }
        });

        add(TableLayoutHelper.createTableLayoutPane(
                new Component[][] {{
                        new UILabel("配置"),preview
                }},
                new double[] { TableLayout.PREFERRED },
                new double[] { TableLayout.FILL,TableLayout.PREFERRED }
        ),BorderLayout.NORTH);

        UIScrollPane loadArea = new UIScrollPane(config);
        add(loadArea, BorderLayout.CENTER);

        UITableModelAdapter<ParameterProvider> model = new ParameterTableModel();
        parameterTableEditorPane = new UITableEditorPane<ParameterProvider>(model);

        add(parameterTableEditorPane, BorderLayout.SOUTH);
    }

    @Override
    public void populateBean(SpData data) {
        if (data == null) {
            return;
        }
        Calculator c = Calculator.createCalculator();
        ParameterProvider[] parameters =  data.getParameters(c);
        parameterTableEditorPane.populate(parameters);
        config.setText( data.getConfig() );
    }

    @Override
    public SpData updateBean() {
        SpData data = new SpData();
        data.setConfig( config.getText() );
        java.util.List<ParameterProvider> parameterProviderList = parameterTableEditorPane.update();
        Parameter[] parameters = parameterProviderList.toArray(new Parameter[parameterProviderList.size()]);
        data.setParameters(parameters);
        return data;
    }

    @Override
    protected String title4PopupWindow() {
        return "Sp Data";
    }
}
